/*
 * Linker script
 */

TARGET("elf32-littlemips")
OUTPUT_ARCH("mips")

ENTRY("_start")

STARTUP(obj/start.o)

SECTIONS
{
	. = 0x00800000;
	__text_start = .;
	.text : { *(.text) }
	. = ALIGN(4);
	__text_end = .;

	__rodata_start = .;
	.rodata : { *(.rodata) *(.rodata.*) }
	. = ALIGN(4);
	__rodata_end = .;

	__data_start = .;
	.data : { *(.data) }
	. = ALIGN(4);
	__data_end = .;

	__bss_start = .;
	.bss : { *(.bss) *(.scommon) }
	. = ALIGN(4);
	__bss_end = .;
}
