/*
 * native.h
 */

#ifndef _NATIVE_H_
#define _NATIVE_H_

extern int __native_start[];
extern int __native_end[];

#define _native_jump_size (256 * 2)
#define _native_jump_base (0x1000)

/* tick */
#define _native_jump_tick_install   ((unsigned int)(*((unsigned short *)(_native_jump_base + 0))))
#define _native_jump_tick_uninstall ((unsigned int)(*((unsigned short *)(_native_jump_base + 2))))
#define _native_jump_tick           ((unsigned int)(*((unsigned short *)(_native_jump_base + 4))))

typedef void (*_tick_install_t)(void);
typedef void (*_tick_uninstall_t)(void);
typedef unsigned int (*_tick_t)(void);

#define _tick_install()   ((_tick_install_t)(_native_jump_tick_install))()
#define _tick_uninstall() ((_tick_uninstall_t)(_native_jump_tick_uninstall))()
#define _tick()           ((_tick_t)(_native_jump_tick))()

/* supercpu */
#define _native_supercpu_turbo      ((unsigned int)(*((unsigned short *)(_native_jump_base + 6))))

typedef void (*_supercpu_turbo_t)(int turbo);

#define _supercpu_turbo(_turbo)     ((_supercpu_turbo_t)(_native_supercpu_turbo))(_turbo)

#endif /* _NATIVE_H_ */
